
--TODO: Save

MsgN("Henry's Animation Tools Server Initiated")

hanim.CurFrame = 1
hanim.FrameBeforePlay = 1
hanim.FrameCount = 1

local frames = {}
local framesOtherData = {}
framesOtherData[1] = {}
framesOtherData[1].framelength = 0.5

function hanim.SetFrame( pl, hand, id, encoded, decoded )
 
	if !hanim.IsPlaying then
		hanim.BeatlemaniaTime(decoded[1])
		hanim.CurFrame = decoded[1]
		datastream.StreamToClients( pl, "hanimClSetFrame", {decoded[1],hanim.GetFrameWang(decoded[1])} )
	end
	
end
datastream.Hook( "hanimSetFrame", hanim.SetFrame )

function hanim.hanimRecordFrame( pl, hand, id, encoded, decoded )

	if !hanim.IsPlaying then
		frames[decoded[1]] = {}
		for k,v in pairs(ents.GetAll()) do
			if !v:IsPlayer() then
				frames[decoded[1]][v] = {}
				frames[decoded[1]][v].weighasdst = 0
				local physc = v:GetPhysicsObjectCount()
				local flexn = v:GetFlexNum()
				for i=0,math.Max(physc-1,flexn-1) do
					if i < physc then
						local physobj = v:GetPhysicsObjectNum(i)
						frames[decoded[1]][v]["phys_"..i] = {}
						frames[decoded[1]][v]["phys_"..i].pos = physobj:GetPos()
						frames[decoded[1]][v]["phys_"..i].ang = physobj:GetAngle()
						frames[decoded[1]][v]["phys_"..i].isfrozen = !physobj:IsMoveable()
						physobj:Sleep()
					end
					if i < flexn then
						frames[decoded[1]][v]["flex_"..i] = v:GetFlexWeight(i)
					end
				end
			end
		end
		if !framesOtherData[decoded[1]] then
			framesOtherData[decoded[1]] = {}
		end
		if decoded[2] then
			framesOtherData[decoded[1]].framelength = decoded[2]
		end
	end

end
datastream.Hook( "hanimRecordFrame", hanim.hanimRecordFrame )

function hanim.hanimClearFrame( pl, hand, id, encoded, decoded )
	if !hanim.IsPlaying then
		frames[decoded[1]] = nil
		framesOtherData[decoded[1]] = {}
		//framesOtherData[decoded[1]].framelength = 0.5
	end
end
datastream.Hook( "hanimClearFrame", hanim.hanimClearFrame )

function hanim.hanimAddFrame( pl, hand, id, encoded, decoded )
	if !hanim.IsPlaying then
		datastream.StreamToClients( player.GetAll(), "hanimClAddFrame", {1} )
		hanim.FrameCount = hanim.FrameCount + 1
		hanim.CurFrame = hanim.FrameCount
		hanim.BeatlemaniaTime(hanim.FrameCount)
		if !framesOtherData[hanim.FrameCount] then
			framesOtherData[hanim.FrameCount] = {}
		end
		framesOtherData[hanim.FrameCount].framelength = hanim.GetFrameWang(hanim.FrameCount-1)
		datastream.StreamToClients( player.GetAll(), "hanimClSetFrame", {hanim.FrameCount,hanim.GetFrameWang(hanim.FrameCount-1)} )
	end
end
datastream.Hook( "hanimAddFrame", hanim.hanimAddFrame )

function hanim.hanimRemoveFrame( pl, hand, id, encoded, decoded )
	if !hanim.IsPlaying then
		datastream.StreamToClients( player.GetAll(), "hanimClRemoveFrame", {1} )
		frames[hanim.FrameCount] = nil
		framesOtherData[hanim.FrameCount] = nil
		hanim.FrameCount = math.Clamp(hanim.FrameCount - 1,0,2600)
		hanim.CurFrame = hanim.FrameCount
		hanim.BeatlemaniaTime(hanim.FrameCount)
	end
end
datastream.Hook( "hanimRemoveFrame", hanim.hanimRemoveFrame )

function hanim.hanimStop( pl, hand, id, encoded, decoded )
	hanim.CurFrame = hanim.FrameBeforePlay
	hanim.BeatlemaniaTime(hanim.CurFrame)
	datastream.StreamToClients( player.GetAll(), "hanimClSetFrame", {hanim.CurFrame,hanim.GetFrameWang(hanim.CurFrame)} )
	hanim.IsPlaying = false
end
datastream.Hook( "hanimStop", hanim.hanimStop )

function hanim.hanimSetCurFrameLength( pl, hand, id, encoded, decoded )
	if !framesOtherData[decoded[1]] then
		framesOtherData[decoded[1]] = {}
	end
	framesOtherData[decoded[1]].framelength = decoded[2]
end
datastream.Hook( "hanimSetCurFrameLength", hanim.hanimSetCurFrameLength )

function hanim.hanimPlay( pl, hand, id, encoded, decoded )
	if !hanim.IsPlaying then
		hanim.IsPlaying = true
		hanim.FrameBeforePlay = hanim.CurFrame
		hanim.CurTime = CurTime()
	end
end
datastream.Hook( "hanimPlay", hanim.hanimPlay )

function hanim.Think()
	if hanim.IsPlaying then
		if CurTime() > hanim.CurTime+hanim.GetFrameWang(hanim.CurFrame,true) then
			hanim.CurFrame = hanim.CurFrame + 1
			hanim.CurTime = CurTime()
			if hanim.CurFrame > hanim.FrameCount then
				hanim.CurFrame = 1
			end
			hanim.BeatlemaniaTime(hanim.CurFrame)
			datastream.StreamToClients( player.GetAll(), "hanimClSetFrame", {hanim.CurFrame,hanim.GetFrameWang(hanim.CurFrame)} )
		end
		hanim.BeatlemaniaTime( hanim.CurFrame,math.Clamp(hanim.CurFrame+1,0,hanim.FrameCount), math.ceil((CurTime()-hanim.CurTime)/hanim.GetFrameWang(hanim.CurFrame)*1000)/1000, true )
	end
end
hook.Add("Think","HAT_Think",hanim.Think)

function hanim.GetFrameWang(n,t)
	if n < 1 then
		return 0.5
	end
	if framesOtherData[n] then
		return framesOtherData[n].framelength
	end
	if t then
		return 0
	end
	return nil
end

function hanim.NormalizeAngle(ang)
	return Angle(math.NormalizeAngle(ang.p),math.NormalizeAngle(ang.y),math.NormalizeAngle(ang.r))
end

function hanim.NAng(a)
	if a < -179 then
		return a + 360
	elseif a > 180 then
		return a - 360
	end
	return a
end

function hanim.AngleCost(s,d,p) // s = start, d = destination, p = percentage you want to get there (1 = 100%, 0.1 = 10%)

	if p == 1 then
		return d
	end
	
	local a1,a2 = 0,0

	if s > d then // Cost depends on which angle goes first
	
		a1 = d + 360 - s // Cost of going right
		a2 = s - d // Cost of going left
	
	elseif s < d then
	
		a1 = d - s // Cost of going right
		a2 = s + 360 - d // Cost of going left
		
	elseif s == d then
		a1 = 0
		a2 = 0
	end
	
	a1 = math.abs(a1)
	a2 = math.abs(a2)
	
	if a1 < a2 then // Compare costs, if the cost of going right is smaller than going left, go right.
		// Todo: Should be adding more, don't know why.
		return hanim.NAng(s + a1*p) // Return starting angle, plus the change in angle. (go right)
	elseif a2 < a1 then
		return hanim.NAng(s - a2*p) // Return starting angle, minus the change in angle. (go left)
	elseif a2 == a1 then
		return hanim.NAng(s - a2*p)
	end
	
end

function hanim.BeatlemaniaTime(n,m,p,t) // n = frame1, m = frame2, p = percentage

	if !m or !p then
		m=n
		p=1
	end
	
	for k,v in pairs(ents.GetAll()) do
		if !v:IsPlayer() then
			if frames[n] then if frames[n][v] then

				local physc = v:GetPhysicsObjectCount()
				local flexn = v:GetFlexNum()
				for i=0,math.Max(physc-1,flexn-1) do

					if i < physc then
						frames[n][v]["phys_"..i].ang = hanim.NormalizeAngle(frames[n][v]["phys_"..i].ang)
						
						local finalv = frames[n][v]["phys_"..i].pos
						local finalp = frames[n][v]["phys_"..i].ang.p
						local finaly = frames[n][v]["phys_"..i].ang.y
						local finalr = frames[n][v]["phys_"..i].ang.r
						if frames[m] then if frames[m][v] then
							frames[m][v]["phys_"..i].ang = hanim.NormalizeAngle(frames[m][v]["phys_"..i].ang)
							local v1 = frames[n][v]["phys_"..i].pos
							local v2 = frames[m][v]["phys_"..i].pos
							local deltavp = (v2-v1)*p
							finalv = v1+deltavp
							//Sadly, physical limbs aren't moved by position but by relative angles.
							finalp = hanim.AngleCost(frames[n][v]["phys_"..i].ang.p,frames[m][v]["phys_"..i].ang.p,p)
							finaly = hanim.AngleCost(frames[n][v]["phys_"..i].ang.y,frames[m][v]["phys_"..i].ang.y,p)
							finalr = hanim.AngleCost(frames[n][v]["phys_"..i].ang.r,frames[m][v]["phys_"..i].ang.r,p)
							
						end end
						
						local finalang = Angle(finalp,finaly,finalr)

						local physobj = v:GetPhysicsObjectNum(i)
						physobj:EnableMotion(true)
						if frames[n][v]["phys_"..i].isfrozen then
							physobj:SetVelocity(Vector(100,100,100))
						end
						physobj:SetPos(finalv)
						physobj:SetAngle(finalang)
						physobj:EnableMotion(false)
						if frames[n][v]["phys_"..i].isfrozen or t then
							physobj:EnableMotion(false)
						elseif !frames[n][v]["phys_"..i].isfrozen then
							physobj:EnableMotion(true)
						end
						physobj:Wake()
					end
					
					if i < flexn then
						local finalw = frames[n][v]["flex_"..i]
						if frames[m] then if frames[m][v] then
							local deltaw = (frames[m][v]["flex_"..i] - frames[n][v]["flex_"..i])*p
							finalw = finalw + deltaw
						end end
						v:SetFlexWeight(i,finalw)
					end

				end


			end end
		end
	end
end
